#!/bin/sh

# vim: sw=4 ts=4

for x in /dev/md/* ; do
  mdadm --stop $x
done

for disk in $(list-harddrives | grep -v fd0 | awk '{printf $1 " "}'); do
	dd if=/dev/zero of=/dev/$disk bs=512 count=32
	parted -s /dev/${disk} mklabel gpt;
done

set $(list-harddrives | grep -v fd0 | grep -v md[0-9] | awk '{printf $1 " "}')
HD1=$1
HD2=$2
HD3=$3
HD4=$4

SIZE1=$(fdisk -l "/dev/${HD1}"  2>/dev/null  | grep Disk | grep dev |  sed 's/://'|awk '{print $5}')

# get disk size in GB
#  DISKSIZE=`parted -sm /dev/$DEV unit GB print | grep -e "$DEV" | cut -d: -f2 | sed -e 's/GB$//'`

EFISIZE=250
RSIZE=17920
BSIZE=500
SWSIZE=$(grep MemTotal /proc/meminfo  | awk '{print int($2/1024)+1}')
if [ ${SWSIZE} -gt 2048 ]; then
    SWSIZE=2048
fi

if [ -d /sys/firmware/efi ]; then
	efibootmgr -v | grep BootCurrent | cut -d' ' -f2 > /tmp/efi_booted
    echo "part raid.11 --size=${EFISIZE} --asprimary --ondisk=${HD1}" >> /tmp/part-include
    echo "part raid.21 --size=${EFISIZE} --asprimary --ondisk=${HD2}" >> /tmp/part-include
    echo "part raid.31 --size=${EFISIZE} --asprimary --ondisk=${HD3}" >> /tmp/part-include
    echo "part raid.41 --size=${EFISIZE} --asprimary --ondisk=${HD4}" >> /tmp/part-include
    echo "raid /boot/efi --fstype efi --level=RAID1 --device=md0 raid.11 raid.21 raid.31 raid.41" >> /tmp/part-include
#    echo "bootloader --location=mbr --boot-drive=${HD1} --driveorder=${HD1},${HD2} --append="consoleblank=0 fsck.repair=yes"" >> /tmp/part-include
elif [ ${SIZE1} -gt 2254857830400 ]; then
	# bios boot partition necessary
	echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HD1}" >> /tmp/part-include
	echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HD2}" >> /tmp/part-include
	echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HD3}" >> /tmp/part-include
	echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HD4}" >> /tmp/part-include
    echo "part raid.11 --size=${BSIZE} --asprimary --ondisk=${HD1}" >> /tmp/part-include
    echo "part raid.21 --size=${BSIZE} --asprimary --ondisk=${HD2}" >> /tmp/part-include
    echo "part raid.31 --size=${BSIZE} --asprimary --ondisk=${HD3}" >> /tmp/part-include
    echo "part raid.41 --size=${BSIZE} --asprimary --ondisk=${HD4}" >> /tmp/part-include
    echo "raid /boot --fstype ext4 --level=RAID1 --device=md0 raid.11 raid.21 raid.31 raid.41" >> /tmp/part-include
fi

cat >> /tmp/part-include << EOF
part raid.12 --size=${RSIZE} --asprimary --ondisk=${HD1}
part raid.13 --size=${SWSIZE} --asprimary --ondisk=${HD1}
part raid.14 --size=1 --grow --asprimary --ondisk=${HD1}

part raid.22 --size=${RSIZE} --asprimary --ondisk=${HD2}
part raid.23 --size=${SWSIZE} --asprimary --ondisk=${HD2}
part raid.24 --size=1 --grow --asprimary --ondisk=${HD2}

part raid.32 --size=${RSIZE} --asprimary --ondisk=${HD3}
part raid.33 --size=${SWSIZE} --asprimary --ondisk=${HD3}
part raid.34 --size=1 --grow --asprimary --ondisk=${HD3}

part raid.42 --size=${RSIZE} --asprimary --ondisk=${HD4}
part raid.43 --size=${SWSIZE} --asprimary --ondisk=${HD4}
part raid.44 --size=1 --grow --asprimary --ondisk=${HD4}

raid / --fstype xfs --level=RAID10 --device=md1 raid.12 raid.22 raid.32 raid.42
raid swap --fstype swap --level=RAID10 --device=md2 raid.13 raid.23 raid.33 raid.43
raid /vm --fstype xfs --level=RAID10 --fsoptions=noatime,nobarrier,logbsize=256k --device=md3 raid.14 raid.24 raid.34 raid.44
EOF
