#!/bin/sh

# vim: sw=4 ts=4

for x in /dev/md/* ; do
  mdadm --stop $x
done

for disk in $(list-harddrives | grep -v fd0 | awk '{printf $1 " "}'); do
	dd if=/dev/zero of=/dev/$disk bs=512 count=32
	parted -s /dev/${disk} mklabel gpt;
done

#SWSIZE=$(grep MemTotal /proc/meminfo  | awk '{print int($2/1024)+1}')
#if [ ${SWSIZE} -gt 2048 ]; then
#	SWSIZE=2048
#fi

set $(list-harddrives | grep -v fd0 | grep -v md[0-9] | awk '{printf $1 " "}')
HD1=$1
HD2=$2
HD3=$3
HD4=$4
HD5=$5
HD6=$6
HD7=$7
HD8=$8
HD9=$9
HDA=${10}
HDB=${11}
HDC=${12}
HDD=${13}
HDE=${14}
HDF=${15}
HDG=${16}

SIZE1=$(fdisk -l "/dev/${HD1}"  2>/dev/null  | grep Disk | grep dev |  sed 's/://'|awk '{print $5}')

# get disk size in GB
#  DISKSIZE=`parted -sm /dev/$DEV unit GB print | grep -e "$DEV" | cut -d: -f2 | sed -e 's/GB$//'`

RSIZE=6144
BSIZE=500
SWSIZE=$(grep MemTotal /proc/meminfo  | awk '{print int($2/1024)+1}')
if [ ${SWSIZE} -gt 1024 ]; then
    SWSIZE=1024
fi

if [ -d /sys/firmware/efi ]; then
	efibootmgr -v | grep BootCurrent | cut -d' ' -f2 > /tmp/efi_booted
    echo "part raid.11 --size=250 --asprimary --ondisk=${HD1}" >> /tmp/part-include
    echo "part raid.21 --size=250 --asprimary --ondisk=${HD2}" >> /tmp/part-include
    echo "part raid.31 --size=250 --asprimary --ondisk=${HD3}" >> /tmp/part-include
    echo "part raid.41 --size=250 --asprimary --ondisk=${HD4}" >> /tmp/part-include
    echo "part raid.51 --size=250 --asprimary --ondisk=${HD5}" >> /tmp/part-include
    echo "part raid.61 --size=250 --asprimary --ondisk=${HD6}" >> /tmp/part-include
    echo "part raid.71 --size=250 --asprimary --ondisk=${HD7}" >> /tmp/part-include
    echo "part raid.81 --size=250 --asprimary --ondisk=${HD8}" >> /tmp/part-include
    echo "part raid.91 --size=250 --asprimary --ondisk=${HD9}" >> /tmp/part-include
    echo "part raid.101 --size=250 --asprimary --ondisk=${HDA}" >> /tmp/part-include
    echo "part raid.111 --size=250 --asprimary --ondisk=${HDB}" >> /tmp/part-include
    echo "part raid.121 --size=250 --asprimary --ondisk=${HDC}" >> /tmp/part-include
    echo "part raid.131 --size=250 --asprimary --ondisk=${HDD}" >> /tmp/part-include
    echo "part raid.141 --size=250 --asprimary --ondisk=${HDE}" >> /tmp/part-include
    echo "part raid.151 --size=250 --asprimary --ondisk=${HDF}" >> /tmp/part-include
    echo "part raid.161 --size=250 --asprimary --ondisk=${HDG}" >> /tmp/part-include
    echo "raid /boot/efi --fstype efi --level=RAID1 --device=md0 raid.11 raid.21 raid.31 raid.41 raid.51 raid.61 raid.71 raid.81 raid.91 raid.101 raid.111 raid.121 raid.131 raid.141 raid.151 raid.161" >> /tmp/part-include
#    echo "bootloader --location=mbr --boot-drive=${HD1} --driveorder=${HD1},${HD2} --append="consoleblank=0 fsck.repair=yes"" >> /tmp/part-include
elif [ ${SIZE1} -gt 2254857830400 ]; then
	# bios boot partition necessary
	echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HD1}" >> /tmp/part-include
	echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HD2}" >> /tmp/part-include
	echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HD3}" >> /tmp/part-include
	echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HD4}" >> /tmp/part-include
    echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HD5}" >> /tmp/part-include
    echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HD6}" >> /tmp/part-include
    echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HD7}" >> /tmp/part-include
    echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HD8}" >> /tmp/part-include
    echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HD9}" >> /tmp/part-include
    echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HDA}" >> /tmp/part-include
    echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HDB}" >> /tmp/part-include
    echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HDC}" >> /tmp/part-include
    echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HDD}" >> /tmp/part-include
    echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HDE}" >> /tmp/part-include
    echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HDF}" >> /tmp/part-include
    echo "part biosboot --fstype=biosboot --size=1 --ondisk=${HDG}" >> /tmp/part-include
fi

cat >> /tmp/part-include << EOF
part raid.12 --size=${BSIZE} --asprimary --ondisk=${HD1}
part raid.13 --size=${RSIZE} --asprimary --ondisk=${HD1}
part raid.14 --size=1 --grow --asprimary --ondisk=${HD1}

part raid.22 --size=${BSIZE} --asprimary --ondisk=${HD2}
part raid.23 --size=${RSIZE} --asprimary --ondisk=${HD2}
part raid.24 --size=1 --grow --asprimary --ondisk=${HD2}

part raid.32 --size=${BSIZE} --asprimary --ondisk=${HD3}
part raid.33 --size=${RSIZE} --asprimary --ondisk=${HD3}
part raid.34 --size=1 --grow --asprimary --ondisk=${HD3}

part raid.42 --size=${BSIZE} --asprimary --ondisk=${HD4}
part raid.43 --size=${RSIZE} --asprimary --ondisk=${HD4}
part raid.44 --size=1 --grow --asprimary --ondisk=${HD4}

part raid.52 --size=${BSIZE} --asprimary --ondisk=${HD5}
part raid.53 --size=${RSIZE} --asprimary --ondisk=${HD5}
part raid.54 --size=1 --grow --asprimary --ondisk=${HD5}

part raid.62 --size=${BSIZE} --asprimary --ondisk=${HD6}
part raid.63 --size=${RSIZE} --asprimary --ondisk=${HD6}
part raid.64 --size=1 --grow --asprimary --ondisk=${HD6}

part raid.72 --size=${BSIZE} --asprimary --ondisk=${HD7}
part raid.73 --size=${RSIZE} --asprimary --ondisk=${HD7}
part raid.74 --size=1 --grow --asprimary --ondisk=${HD7}

part raid.82 --size=${BSIZE} --asprimary --ondisk=${HD8}
part raid.83 --size=${RSIZE} --asprimary --ondisk=${HD8}
part raid.84 --size=1 --grow --asprimary --ondisk=${HD8}

part raid.92 --size=${BSIZE} --asprimary --ondisk=${HD9}
part raid.93 --size=${RSIZE} --asprimary --ondisk=${HD9}
part raid.94 --size=1 --grow --asprimary --ondisk=${HD9}

part raid.102 --size=${BSIZE} --asprimary --ondisk=${HDA}
part raid.103 --size=${RSIZE} --asprimary --ondisk=${HDA}
part raid.104 --size=1 --grow --asprimary --ondisk=${HDA}

part raid.112 --size=${BSIZE} --asprimary --ondisk=${HDB}
part raid.113 --size=${RSIZE} --asprimary --ondisk=${HDB}
part raid.114 --size=1 --grow --asprimary --ondisk=${HDB}

part raid.122 --size=${BSIZE} --asprimary --ondisk=${HDC}
part raid.123 --size=${RSIZE} --asprimary --ondisk=${HDC}
part raid.124 --size=1 --grow --asprimary --ondisk=${HDC}

part raid.132 --size=${BSIZE} --asprimary --ondisk=${HDD}
part raid.133 --size=${RSIZE} --asprimary --ondisk=${HDD}
part raid.134 --size=1 --grow --asprimary --ondisk=${HDD}

part raid.142 --size=${BSIZE} --asprimary --ondisk=${HDE}
part raid.143 --size=${RSIZE} --asprimary --ondisk=${HDE}
part raid.144 --size=1 --grow --asprimary --ondisk=${HDE}

part raid.152 --size=${BSIZE} --asprimary --ondisk=${HDF}
part raid.153 --size=${RSIZE} --asprimary --ondisk=${HDF}
part raid.154 --size=1 --grow --asprimary --ondisk=${HDF}

part raid.162 --size=${BSIZE} --asprimary --ondisk=${HDG}
part raid.163 --size=${RSIZE} --asprimary --ondisk=${HDG}
part raid.164 --size=1 --grow --asprimary --ondisk=${HDG}

raid /boot --fstype ext4 --level=RAID1 --device=md1 raid.12 raid.22 raid.32 raid.42 raid.52 raid.62 raid.72 raid.82  raid.92 raid.102 raid.112 raid.122 raid.132 raid.142 raid.152 raid.162
raid / --fstype xfs --level=RAID10 --device=md2 raid.13 raid.23 raid.33 raid.43 raid.53 raid.63 raid.73 raid.83  raid.93 raid.103 raid.113 raid.123 raid.133 raid.143 raid.153 raid.163
raid /backup --fstype xfs --level=RAID10 --fsoptions=noatime,nobarrier,logbsize=256k --device=md3 raid.14 raid.24 raid.34 raid.44  raid.54 raid.64 raid.74 raid.84  raid.94 raid.104 raid.114 raid.124 raid.134 raid.144 raid.154 raid.164
EOF
